'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = crate;

var _react = require('react');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var isFn = function isFn(test) {
  return typeof test === 'function';
};
var id = function id(Component) {
  return Component;
};

var Crate = function () {
  function Crate() {
    var hoc = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : id;

    _classCallCheck(this, Crate);

    this.hocFn = hoc;
    return this;
  }

  Crate.prototype.map = function map(fn) {
    return new Crate(fn(this.hocFn));
  };

  Crate.prototype.fold = function fold(fn) {
    return fn(this.hocFn);
  };

  Crate.prototype.compile = function compile(Component) {
    return this.fold(function (hoc) {
      return hoc(Component);
    });
  };

  Crate.prototype.hoc = function hoc(fn) {
    return this.map(function (hoc) {
      return function (Wrapped) {
        return fn(hoc(Wrapped));
      };
    });
  };

  // Inspect your props at a certain point


  Crate.prototype.inspect = function inspect() {
    var _this = this;

    return this.map(function (hoc) {
      return function (Wrapped) {
        return hoc(function (props) {
          console.log('=== inspect ===');
          console.log('props', props);
          console.log('this.hocFn', _this.hocFn);
          console.log('===============');
          return (0, _react.createElement)(Wrapped, props);
        });
      };
    });
  };

  // Set prop by key


  Crate.prototype.prop = function prop(key, value) {
    return this.map(function (hoc) {
      return function (Wrapped) {
        return hoc(function (props) {
          var _extends2;

          var nextProps = _extends({}, props, (_extends2 = {}, _extends2[key] = isFn(value) ? value(props) : value, _extends2));
          return (0, _react.createElement)(Wrapped, nextProps);
        });
      };
    });
  };

  // Set className prop
  // accepts anything that `classnames`
  // https://www.npmjs.com/package/classnames


  Crate.prototype.className = function className(value) {
    return this.prop('className', function (props) {
      return (0, _classnames2.default)(props.className, isFn(value) ? value(props) : value);
    });
  };

  // Set style


  Crate.prototype.style = function style(s) {
    return this.prop('style', function (props) {
      return _extends({}, props.style, isFn(s) ? s(props) : s);
    });
  };

  return Crate;
}();

function crate() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return new (Function.prototype.bind.apply(Crate, [null].concat(args)))();
}
module.exports = exports['default'];